<?php

require_once("vendor/flexi/flexi.php");
require_once("lib/visual.inc.php");
require_once("lib/classes/UserManagement.class.php");

class Wikifarmuebersicht extends StudIPPlugin implements AdministrationPlugin {
	
	private $EIM = "pmwikifarm";

	//	Konfiguration
	//	-------------
	//
	//	private $EIM = 'wikifarm_id';
	//
	//	Wobei 'wikifarm_id' in der Datei /config/config_local.inc.php
	//	zur Konfiguration der Lernmodulschnittstelle definiert wird:
	//
	//	$ELEARNING_INTERFACE_MODULES['wikifarm_id'] = array( .. )

    function __construct()
    {
        if ($GLOBALS['perm']->have_perm("root")) {
            Navigation::addItem('/admin/tools/wikifarmuebersicht', new Navigation($this->getPluginName(), PluginEngine::getUrl($this)));
        }
    }

    function show_action()
    {
		$GLOBALS['perm']->check("root");
		Navigation::activateItem('/admin/tools/wikifarmuebersicht');

		$factory = new Flexi_TemplateFactory(dirname(__FILE__)."/templates");
		$template = $factory->open("index");

		if($this->_check())
		{
			$template->set_attribute('seminarsAll', $this->_findAllSeminars());
			$template->set_attribute('institutesAll', $this->_findAllInstitutes());
		}
		else
			$template->set_attribute('eim_invalid', 'eim_invalid');	
		
		$template->set_layout('layout.php');
		$template->set_attribute('plugin', $this);
        
		echo $template->render();
    }

	function getPluginname(){
		return _("Wikifarm-bersicht");
	}

	function _findAllSeminars(){

		$sql = "SELECT oc.*, s.Seminar_id, s.Name, s.Untertitel FROM object_contentmodules oc JOIN seminare s ON (oc.object_id = s.Seminar_id) WHERE oc.system_type = '$this->EIM' AND oc.module_type = 'wiki' ORDER BY oc.module_id, s.Name ASC";
		$result = $this->_sqlQuery($sql);
		
		return $result;
	}
	
	function _findAllInstitutes(){

		$sql = "SELECT oc.*, i.Institut_id, i.Name, i.fakultaets_id FROM object_contentmodules oc JOIN Institute i ON (oc.object_id = i.Institut_id) WHERE oc.system_type = '$this->EIM' AND oc.module_type = 'wiki' ORDER BY oc.module_id, i.Name ASC";
		$result = $this->_sqlQuery($sql);
		
		return $result;
	}

	function _sqlQuery($sql){

		if(trim($sql) == "")
			return null;
		else
		{
			$db = DBManager::get();			
			return $db->query($sql);
		}
	}
	
	function _check(){
	
	    global $ELEARNING_INTERFACE_MODULES;
	    
	    if(is_array($ELEARNING_INTERFACE_MODULES) && array_key_exists($this->EIM, $ELEARNING_INTERFACE_MODULES))
			return true;
		
		return false;
	}
}

		
